blob: 3a13397e057edf88d2c810490ec3d7d755be2009 [file] [log] [blame]
Lars Hjemli70c7ac22007-05-26 15:56:40 +02001#!/bin/sh
2#
Sven Verdoolaegeecda0722007-06-24 23:06:07 +02003# git-submodules.sh: add, init, update or list git submodules
Lars Hjemli70c7ac22007-05-26 15:56:40 +02004#
5# Copyright (c) 2007 Lars Hjemli
6
Johan Herland1d5bec82009-08-19 03:45:19 +02007dashless=$(basename "$0" | sed -e 's/-/ /')
Jens Lehmannd27b8762010-07-17 17:11:43 +02008USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
Johan Herland64b19ff2009-08-19 03:45:24 +02009 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
Johan Herland1d5bec82009-08-19 03:45:19 +020010 or: $dashless [--quiet] init [--] [<path>...]
Johan Herlandb13fd5c2009-08-19 03:45:23 +020011 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
Junio C Hamanoadc54232009-08-27 16:59:25 -070012 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
Johan Herland15fc56a2009-08-19 03:45:22 +020013 or: $dashless [--quiet] foreach [--recursive] <command>
Johan Herland1d5bec82009-08-19 03:45:19 +020014 or: $dashless [--quiet] sync [--] [<path>...]"
Junio C Hamano8f321a32007-11-06 01:50:02 -080015OPTIONS_SPEC=
Lars Hjemli70c7ac22007-05-26 15:56:40 +020016. git-sh-setup
Mark Levedahl98fcf842008-08-24 14:46:10 -040017. git-parse-remote
Lars Hjemli70c7ac22007-05-26 15:56:40 +020018require_work_tree
19
Junio C Hamano5c08dbb2008-01-15 02:48:45 -080020command=
Sven Verdoolaegeecda0722007-06-24 23:06:07 +020021branch=
Jens Lehmannd27b8762010-07-17 17:11:43 +020022force=
Michael S. Tsirkind92a3952009-05-04 22:30:01 +030023reference=
Lars Hjemli70c7ac22007-05-26 15:56:40 +020024cached=
Gerrit Pape48bb3032010-04-26 11:50:39 +020025recursive=
26init=
Jens Lehmann1c244f62009-08-13 21:32:50 +020027files=
Fabian Franz31ca3ac2009-02-05 20:18:32 -020028nofetch=
Johan Herland32948422009-06-03 08:27:06 +020029update=
Johan Herland15fc56a2009-08-19 03:45:22 +020030prefix=
Lars Hjemli70c7ac22007-05-26 15:56:40 +020031
Mark Levedahlf31a5222007-09-23 22:19:42 -040032# Resolve relative url by appending to parent's url
33resolve_relative_url ()
34{
Mark Levedahl98fcf842008-08-24 14:46:10 -040035 remote=$(get_default_remote)
Mark Levedahl8e7e6f32008-06-14 13:09:41 -040036 remoteurl=$(git config "remote.$remote.url") ||
37 die "remote ($remote) does not have a url defined in .git/config"
Mark Levedahlf31a5222007-09-23 22:19:42 -040038 url="$1"
Mark Levedahl99b120a2008-08-21 19:54:01 -040039 remoteurl=${remoteurl%/}
Thomas Rastea640cc2011-01-10 11:37:26 +010040 sep=/
Mark Levedahlf31a5222007-09-23 22:19:42 -040041 while test -n "$url"
42 do
43 case "$url" in
44 ../*)
45 url="${url#../}"
Thomas Rastea640cc2011-01-10 11:37:26 +010046 case "$remoteurl" in
47 */*)
48 remoteurl="${remoteurl%/*}"
49 ;;
50 *:*)
51 remoteurl="${remoteurl%:*}"
52 sep=:
53 ;;
54 *)
55 die "cannot strip one component off url '$remoteurl'"
56 ;;
57 esac
Mark Levedahlf31a5222007-09-23 22:19:42 -040058 ;;
59 ./*)
60 url="${url#./}"
61 ;;
62 *)
63 break;;
64 esac
65 done
Thomas Rastea640cc2011-01-10 11:37:26 +010066 echo "$remoteurl$sep${url%/}"
Mark Levedahlf31a5222007-09-23 22:19:42 -040067}
68
Lars Hjemli941987a2007-06-11 21:12:24 +020069#
David Aguilara7b32692008-08-22 00:30:50 -070070# Get submodule info for registered submodules
71# $@ = path to limit submodule list
72#
73module_list()
74{
Junio C Hamanoe1622bf2009-11-23 15:56:32 -080075 git ls-files --error-unmatch --stage -- "$@" | sane_grep '^160000 '
David Aguilara7b32692008-08-22 00:30:50 -070076}
77
78#
Lars Hjemli941987a2007-06-11 21:12:24 +020079# Map submodule path to submodule name
80#
81# $1 = path
82#
83module_name()
84{
Junio C Hamano537601a2007-07-25 15:51:26 -070085 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
Chris Riddfe22e542008-06-11 14:09:19 +010086 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
Imran M Yousufa5099bb2008-05-15 13:42:58 +060087 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
Junio C Hamano537601a2007-07-25 15:51:26 -070088 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
Lars Hjemli941987a2007-06-11 21:12:24 +020089 test -z "$name" &&
90 die "No submodule mapping found in .gitmodules for path '$path'"
91 echo "$name"
92}
Lars Hjemli33aa6ff2007-06-06 11:13:01 +020093
94#
95# Clone a submodule
96#
Junio C Hamano23a485e2008-01-15 02:35:49 -080097# Prior to calling, cmd_update checks that a possibly existing
Sven Verdoolaegeecda0722007-06-24 23:06:07 +020098# path is not a git repository.
Junio C Hamano23a485e2008-01-15 02:35:49 -080099# Likewise, cmd_add checks that path does not exist at all,
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200100# since it is the location of a new submodule.
101#
Lars Hjemli33aa6ff2007-06-06 11:13:01 +0200102module_clone()
103{
104 path=$1
105 url=$2
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300106 reference="$3"
Lars Hjemli33aa6ff2007-06-06 11:13:01 +0200107
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300108 if test -n "$reference"
109 then
110 git-clone "$reference" -n "$url" "$path"
111 else
112 git-clone -n "$url" "$path"
113 fi ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200114 die "Clone of '$url' into submodule path '$path' failed"
Lars Hjemli33aa6ff2007-06-06 11:13:01 +0200115}
116
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200117#
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200118# Add a new submodule to the working tree, .gitmodules and the index
119#
Mark Levedahlec05df32008-07-09 21:05:40 -0400120# $@ = repo path
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200121#
122# optional branch is stored in global branch variable
123#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800124cmd_add()
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200125{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800126 # parse $args after "submodule ... add".
127 while test $# -ne 0
128 do
129 case "$1" in
130 -b | --branch)
131 case "$2" in '') usage ;; esac
132 branch=$2
133 shift
134 ;;
Jens Lehmannd27b8762010-07-17 17:11:43 +0200135 -f | --force)
136 force=$1
137 ;;
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800138 -q|--quiet)
Stephen Boyd2e6a30e2009-06-16 15:33:00 -0700139 GIT_QUIET=1
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800140 ;;
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300141 --reference)
142 case "$2" in '') usage ;; esac
143 reference="--reference=$2"
144 shift
145 ;;
146 --reference=*)
147 reference="$1"
148 shift
149 ;;
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800150 --)
151 shift
152 break
153 ;;
154 -*)
155 usage
156 ;;
157 *)
158 break
159 ;;
160 esac
161 shift
162 done
163
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200164 repo=$1
165 path=$2
166
Jens Lehmann1414e572009-09-22 17:10:12 +0200167 if test -z "$path"; then
168 path=$(echo "$repo" |
169 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
170 fi
171
Mark Levedahlec05df32008-07-09 21:05:40 -0400172 if test -z "$repo" -o -z "$path"; then
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200173 usage
174 fi
175
Mark Levedahlec05df32008-07-09 21:05:40 -0400176 # assure repo is absolute or relative to parent
177 case "$repo" in
178 ./*|../*)
179 # dereference source url relative to parent's url
180 realrepo=$(resolve_relative_url "$repo") || exit
181 ;;
182 *:*|/*)
183 # absolute url
184 realrepo=$repo
185 ;;
186 *)
187 die "repo URL: '$repo' must be absolute or begin with ./|../"
188 ;;
189 esac
190
Michael J Gruberdb75ada2009-03-03 16:08:21 +0100191 # normalize path:
192 # multiple //; leading ./; /./; /../; trailing /
193 path=$(printf '%s/\n' "$path" |
194 sed -e '
195 s|//*|/|g
196 s|^\(\./\)*||
197 s|/\./|/|g
198 :start
199 s|\([^/]*\)/\.\./||
200 tstart
201 s|/*$||
202 ')
Junio C Hamano5be60072007-07-02 22:52:14 -0700203 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200204 die "'$path' already exists in the index"
205
Jens Lehmannd27b8762010-07-17 17:11:43 +0200206 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
207 then
208 echo >&2 "The following path is ignored by one of your .gitignore files:" &&
209 echo >&2 $path &&
210 echo >&2 "Use -f if you really want to add it."
211 exit 1
212 fi
213
Mark Levedahld4264ca2008-03-04 20:15:02 -0500214 # perhaps the path exists and is already a git repo, else clone it
215 if test -e "$path"
216 then
Mark Levedahle9656472008-07-07 22:36:40 -0400217 if test -d "$path"/.git -o -f "$path"/.git
Mark Levedahld4264ca2008-03-04 20:15:02 -0500218 then
219 echo "Adding existing repo at '$path' to the index"
220 else
221 die "'$path' already exists and is not a valid git repo"
222 fi
Mark Levedahlc2f93912008-07-09 21:05:41 -0400223
224 case "$repo" in
225 ./*|../*)
226 url=$(resolve_relative_url "$repo") || exit
227 ;;
228 *)
229 url="$repo"
230 ;;
231 esac
232 git config submodule."$path".url "$url"
Mark Levedahld4264ca2008-03-04 20:15:02 -0500233 else
Mark Levedahld4264ca2008-03-04 20:15:02 -0500234
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300235 module_clone "$path" "$realrepo" "$reference" || exit
Ben Jacksonea10b602009-04-18 20:42:07 -0700236 (
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100237 clear_local_git_env
Ben Jacksonea10b602009-04-18 20:42:07 -0700238 cd "$path" &&
239 # ash fails to wordsplit ${branch:+-b "$branch"...}
240 case "$branch" in
241 '') git checkout -f -q ;;
Jonathan Nieder502dc5b2010-12-01 12:50:46 -0600242 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
Ben Jacksonea10b602009-04-18 20:42:07 -0700243 esac
244 ) || die "Unable to checkout submodule '$path'"
Mark Levedahld4264ca2008-03-04 20:15:02 -0500245 fi
246
Jens Lehmannd27b8762010-07-17 17:11:43 +0200247 git add $force "$path" ||
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200248 die "Failed to add submodule '$path'"
249
Imran M Yousufa5099bb2008-05-15 13:42:58 +0600250 git config -f .gitmodules submodule."$path".path "$path" &&
251 git config -f .gitmodules submodule."$path".url "$repo" &&
Ævar Arnfjörð Bjarmason31991b02010-07-05 17:33:03 +0000252 git add --force .gitmodules ||
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200253 die "Failed to register submodule '$path'"
254}
255
256#
Mark Levedahl19a31f92008-08-10 19:10:04 -0400257# Execute an arbitrary command sequence in each checked out
258# submodule
259#
260# $@ = command to execute
261#
262cmd_foreach()
263{
Johan Herland1d5bec82009-08-19 03:45:19 +0200264 # parse $args after "submodule ... foreach".
265 while test $# -ne 0
266 do
267 case "$1" in
268 -q|--quiet)
269 GIT_QUIET=1
270 ;;
Johan Herland15fc56a2009-08-19 03:45:22 +0200271 --recursive)
272 recursive=1
273 ;;
Johan Herland1d5bec82009-08-19 03:45:19 +0200274 -*)
275 usage
276 ;;
277 *)
278 break
279 ;;
280 esac
281 shift
282 done
283
Ævar Arnfjörð Bjarmasonf030c962010-05-21 16:10:10 +0000284 toplevel=$(pwd)
285
David Aguilara7b32692008-08-22 00:30:50 -0700286 module_list |
Mark Levedahl19a31f92008-08-10 19:10:04 -0400287 while read mode sha1 stage path
288 do
289 if test -e "$path"/.git
290 then
Johan Herland15fc56a2009-08-19 03:45:22 +0200291 say "Entering '$prefix$path'"
Johan Herland1e7f2aa2009-08-16 03:10:08 +0200292 name=$(module_name "$path")
Johan Herland15fc56a2009-08-19 03:45:22 +0200293 (
294 prefix="$prefix$path/"
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100295 clear_local_git_env
Johan Herland15fc56a2009-08-19 03:45:22 +0200296 cd "$path" &&
297 eval "$@" &&
298 if test -n "$recursive"
299 then
300 cmd_foreach "--recursive" "$@"
301 fi
302 ) ||
Mark Levedahl19a31f92008-08-10 19:10:04 -0400303 die "Stopping at '$path'; script returned non-zero status."
304 fi
305 done
306}
307
308#
Lars Hjemli211b7f12007-06-06 11:13:02 +0200309# Register submodules in .git/config
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200310#
311# $@ = requested paths (default to all)
312#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800313cmd_init()
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200314{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800315 # parse $args after "submodule ... init".
316 while test $# -ne 0
317 do
318 case "$1" in
319 -q|--quiet)
Stephen Boyd2e6a30e2009-06-16 15:33:00 -0700320 GIT_QUIET=1
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800321 ;;
322 --)
323 shift
324 break
325 ;;
326 -*)
327 usage
328 ;;
329 *)
330 break
331 ;;
332 esac
333 shift
334 done
335
David Aguilara7b32692008-08-22 00:30:50 -0700336 module_list "$@" |
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200337 while read mode sha1 stage path
338 do
Lars Hjemli211b7f12007-06-06 11:13:02 +0200339 # Skip already registered paths
Lars Hjemli941987a2007-06-11 21:12:24 +0200340 name=$(module_name "$path") || exit
Junio C Hamano5be60072007-07-02 22:52:14 -0700341 url=$(git config submodule."$name".url)
Lars Hjemli211b7f12007-06-06 11:13:02 +0200342 test -z "$url" || continue
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200343
Imran M Yousufa5099bb2008-05-15 13:42:58 +0600344 url=$(git config -f .gitmodules submodule."$name".url)
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200345 test -z "$url" &&
Lars Hjemli941987a2007-06-11 21:12:24 +0200346 die "No url found for submodule path '$path' in .gitmodules"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200347
Mark Levedahlf31a5222007-09-23 22:19:42 -0400348 # Possibly a url relative to parent
349 case "$url" in
350 ./*|../*)
Mark Levedahl8e7e6f32008-06-14 13:09:41 -0400351 url=$(resolve_relative_url "$url") || exit
Mark Levedahlf31a5222007-09-23 22:19:42 -0400352 ;;
353 esac
354
Junio C Hamano5be60072007-07-02 22:52:14 -0700355 git config submodule."$name".url "$url" ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200356 die "Failed to register url for submodule path '$path'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200357
Johan Herland32948422009-06-03 08:27:06 +0200358 upd="$(git config -f .gitmodules submodule."$name".update)"
359 test -z "$upd" ||
360 git config submodule."$name".update "$upd" ||
361 die "Failed to register update mode for submodule path '$path'"
Peter Huttererca2cedb2009-04-24 09:06:38 +1000362
Lars Hjemli941987a2007-06-11 21:12:24 +0200363 say "Submodule '$name' ($url) registered for path '$path'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200364 done
365}
366
367#
Lars Hjemli211b7f12007-06-06 11:13:02 +0200368# Update each submodule path to correct revision, using clone and checkout as needed
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200369#
370# $@ = requested paths (default to all)
371#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800372cmd_update()
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200373{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800374 # parse $args after "submodule ... update".
Kevin Ballard98dbe632010-11-02 23:26:25 -0700375 orig_flags=
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800376 while test $# -ne 0
377 do
378 case "$1" in
379 -q|--quiet)
Stephen Boyd2e6a30e2009-06-16 15:33:00 -0700380 GIT_QUIET=1
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800381 ;;
Johannes Schindelinbe4d2c82008-05-16 11:23:03 +0100382 -i|--init)
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300383 init=1
Johannes Schindelinbe4d2c82008-05-16 11:23:03 +0100384 ;;
Fabian Franz31ca3ac2009-02-05 20:18:32 -0200385 -N|--no-fetch)
Fabian Franz31ca3ac2009-02-05 20:18:32 -0200386 nofetch=1
387 ;;
Peter Huttererca2cedb2009-04-24 09:06:38 +1000388 -r|--rebase)
Johan Herland32948422009-06-03 08:27:06 +0200389 update="rebase"
Peter Huttererca2cedb2009-04-24 09:06:38 +1000390 ;;
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300391 --reference)
392 case "$2" in '') usage ;; esac
393 reference="--reference=$2"
Kevin Ballard98dbe632010-11-02 23:26:25 -0700394 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
395 shift
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300396 ;;
397 --reference=*)
398 reference="$1"
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300399 ;;
Johan Herland42b49172009-06-03 00:59:12 +0200400 -m|--merge)
Johan Herland42b49172009-06-03 00:59:12 +0200401 update="merge"
402 ;;
Johan Herlandb13fd5c2009-08-19 03:45:23 +0200403 --recursive)
Johan Herlandb13fd5c2009-08-19 03:45:23 +0200404 recursive=1
405 ;;
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800406 --)
407 shift
408 break
409 ;;
410 -*)
411 usage
412 ;;
413 *)
414 break
415 ;;
416 esac
Kevin Ballard98dbe632010-11-02 23:26:25 -0700417 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
418 shift
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800419 done
420
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300421 if test -n "$init"
422 then
423 cmd_init "--" "$@" || return
424 fi
425
Spencer E. Olson1b4735d2011-02-17 09:18:45 -0700426 cloned_modules=
David Aguilara7b32692008-08-22 00:30:50 -0700427 module_list "$@" |
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200428 while read mode sha1 stage path
429 do
Lars Hjemli941987a2007-06-11 21:12:24 +0200430 name=$(module_name "$path") || exit
Junio C Hamano5be60072007-07-02 22:52:14 -0700431 url=$(git config submodule."$name".url)
Johan Herland32948422009-06-03 08:27:06 +0200432 update_module=$(git config submodule."$name".update)
Lars Hjemli211b7f12007-06-06 11:13:02 +0200433 if test -z "$url"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200434 then
435 # Only mention uninitialized submodules when its
436 # path have been specified
437 test "$#" != "0" &&
Alexandre Julliard989206f2008-11-11 22:09:16 +0100438 say "Submodule path '$path' not initialized" &&
Johannes Schindelinbe4d2c82008-05-16 11:23:03 +0100439 say "Maybe you want to use 'update --init'?"
Lars Hjemli211b7f12007-06-06 11:13:02 +0200440 continue
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200441 fi
Lars Hjemli211b7f12007-06-06 11:13:02 +0200442
Lars Hjemliba88a1f2008-02-20 23:13:15 +0100443 if ! test -d "$path"/.git -o -f "$path"/.git
Lars Hjemli211b7f12007-06-06 11:13:02 +0200444 then
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300445 module_clone "$path" "$url" "$reference"|| exit
Spencer E. Olson1b4735d2011-02-17 09:18:45 -0700446 cloned_modules="$cloned_modules;$name"
Lars Hjemlibf2d8242007-06-11 21:12:22 +0200447 subsha1=
448 else
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100449 subsha1=$(clear_local_git_env; cd "$path" &&
Junio C Hamano5be60072007-07-02 22:52:14 -0700450 git rev-parse --verify HEAD) ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200451 die "Unable to find current revision in submodule path '$path'"
Lars Hjemli211b7f12007-06-06 11:13:02 +0200452 fi
453
Johan Herland32948422009-06-03 08:27:06 +0200454 if ! test -z "$update"
Peter Huttererca2cedb2009-04-24 09:06:38 +1000455 then
Johan Herland32948422009-06-03 08:27:06 +0200456 update_module=$update
Peter Huttererca2cedb2009-04-24 09:06:38 +1000457 fi
458
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200459 if test "$subsha1" != "$sha1"
460 then
Ping Yinb9b378a2008-09-26 23:33:23 +0800461 force=
462 if test -z "$subsha1"
463 then
464 force="-f"
465 fi
Fabian Franz31ca3ac2009-02-05 20:18:32 -0200466
467 if test -z "$nofetch"
468 then
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100469 (clear_local_git_env; cd "$path" &&
Fabian Franz31ca3ac2009-02-05 20:18:32 -0200470 git-fetch) ||
471 die "Unable to fetch in submodule path '$path'"
472 fi
473
Spencer E. Olson1b4735d2011-02-17 09:18:45 -0700474 # Is this something we just cloned?
475 case ";$cloned_modules;" in
476 *";$name;"*)
477 # then there is no local change to integrate
478 update_module= ;;
479 esac
480
Johan Herland32948422009-06-03 08:27:06 +0200481 case "$update_module" in
482 rebase)
483 command="git rebase"
Peter Huttererca2cedb2009-04-24 09:06:38 +1000484 action="rebase"
485 msg="rebased onto"
Johan Herland32948422009-06-03 08:27:06 +0200486 ;;
Johan Herland42b49172009-06-03 00:59:12 +0200487 merge)
488 command="git merge"
489 action="merge"
490 msg="merged in"
491 ;;
Johan Herland32948422009-06-03 08:27:06 +0200492 *)
493 command="git checkout $force -q"
Peter Huttererca2cedb2009-04-24 09:06:38 +1000494 action="checkout"
495 msg="checked out"
Johan Herland32948422009-06-03 08:27:06 +0200496 ;;
497 esac
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200498
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100499 (clear_local_git_env; cd "$path" && $command "$sha1") ||
Peter Huttererca2cedb2009-04-24 09:06:38 +1000500 die "Unable to $action '$sha1' in submodule path '$path'"
501 say "Submodule path '$path': $msg '$sha1'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200502 fi
Johan Herlandb13fd5c2009-08-19 03:45:23 +0200503
504 if test -n "$recursive"
505 then
Kevin Ballard98dbe632010-11-02 23:26:25 -0700506 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags") ||
Johan Herlandb13fd5c2009-08-19 03:45:23 +0200507 die "Failed to recurse into submodule path '$path'"
508 fi
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200509 done
510}
511
Emil Medvebffe71f2007-06-26 18:40:58 -0500512set_name_rev () {
513 revname=$( (
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100514 clear_local_git_env
Emil Medvebffe71f2007-06-26 18:40:58 -0500515 cd "$1" && {
Junio C Hamano5be60072007-07-02 22:52:14 -0700516 git describe "$2" 2>/dev/null ||
517 git describe --tags "$2" 2>/dev/null ||
Mark Levedahlf669ac02008-04-14 22:48:06 -0400518 git describe --contains "$2" 2>/dev/null ||
519 git describe --all --always "$2"
Emil Medvebffe71f2007-06-26 18:40:58 -0500520 }
521 ) )
522 test -z "$revname" || revname=" ($revname)"
523}
Ping Yin28f9af52008-03-11 21:52:15 +0800524#
525# Show commit summary for submodules in index or working tree
526#
527# If '--cached' is given, show summary between index and given commit,
528# or between working tree and given commit
529#
530# $@ = [commit (default 'HEAD'),] requested paths (default all)
531#
532cmd_summary() {
Ping Yinf2dc06a2008-03-11 21:52:17 +0800533 summary_limit=-1
Ping Yind0f64dd2008-04-12 23:05:31 +0800534 for_status=
Jens Lehmann1c244f62009-08-13 21:32:50 +0200535 diff_cmd=diff-index
Emil Medvebffe71f2007-06-26 18:40:58 -0500536
Ping Yin28f9af52008-03-11 21:52:15 +0800537 # parse $args after "submodule ... summary".
538 while test $# -ne 0
539 do
540 case "$1" in
541 --cached)
542 cached="$1"
543 ;;
Jens Lehmann1c244f62009-08-13 21:32:50 +0200544 --files)
545 files="$1"
546 ;;
Ping Yind0f64dd2008-04-12 23:05:31 +0800547 --for-status)
548 for_status="$1"
549 ;;
Ping Yinf2dc06a2008-03-11 21:52:17 +0800550 -n|--summary-limit)
551 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
552 then
553 :
554 else
555 usage
556 fi
557 shift
558 ;;
Ping Yin28f9af52008-03-11 21:52:15 +0800559 --)
560 shift
561 break
562 ;;
563 -*)
564 usage
565 ;;
566 *)
567 break
568 ;;
569 esac
570 shift
571 done
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200572
Ping Yinf2dc06a2008-03-11 21:52:17 +0800573 test $summary_limit = 0 && return
574
Johan Herland3deea892010-02-16 11:21:14 +0100575 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
Ping Yin28f9af52008-03-11 21:52:15 +0800576 then
577 head=$rev
Jeff Kingcaa9c3c2010-03-03 14:19:09 -0800578 test $# = 0 || shift
Johan Herland3deea892010-02-16 11:21:14 +0100579 elif test -z "$1" -o "$1" = "HEAD"
580 then
Junio C Hamano14e940d2010-03-03 14:19:10 -0800581 # before the first commit: compare with an empty tree
582 head=$(git hash-object -w -t tree --stdin </dev/null)
Jens Lehmann2ea6c2c2010-03-09 15:55:32 +0100583 test -z "$1" || shift
Ping Yin28f9af52008-03-11 21:52:15 +0800584 else
Johan Herland3deea892010-02-16 11:21:14 +0100585 head="HEAD"
Ping Yin28f9af52008-03-11 21:52:15 +0800586 fi
587
Jens Lehmann1c244f62009-08-13 21:32:50 +0200588 if [ -n "$files" ]
589 then
590 test -n "$cached" &&
591 die "--cached cannot be used with --files"
592 diff_cmd=diff-files
593 head=
594 fi
595
Ping Yin28f9af52008-03-11 21:52:15 +0800596 cd_to_toplevel
597 # Get modified modules cared by user
Jens Lehmann18076502010-06-25 16:56:02 +0200598 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
Junio C Hamanoe1622bf2009-11-23 15:56:32 -0800599 sane_egrep '^:([0-7]* )?160000' |
Ping Yin28f9af52008-03-11 21:52:15 +0800600 while read mod_src mod_dst sha1_src sha1_dst status name
601 do
602 # Always show modules deleted or type-changed (blob<->module)
603 test $status = D -o $status = T && echo "$name" && continue
604 # Also show added or modified modules which are checked out
605 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
606 echo "$name"
607 done
608 )
Ping Yin1cb639e2008-03-11 21:52:16 +0800609
Ping Yind0f64dd2008-04-12 23:05:31 +0800610 test -z "$modules" && return
611
Jens Lehmann18076502010-06-25 16:56:02 +0200612 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
Junio C Hamanoe1622bf2009-11-23 15:56:32 -0800613 sane_egrep '^:([0-7]* )?160000' |
Ping Yin1cb639e2008-03-11 21:52:16 +0800614 cut -c2- |
615 while read mod_src mod_dst sha1_src sha1_dst status name
616 do
617 if test -z "$cached" &&
618 test $sha1_dst = 0000000000000000000000000000000000000000
619 then
620 case "$mod_dst" in
621 160000)
622 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
623 ;;
624 100644 | 100755 | 120000)
625 sha1_dst=$(git hash-object $name)
626 ;;
627 000000)
628 ;; # removed
629 *)
630 # unexpected type
631 echo >&2 "unexpected mode $mod_dst"
632 continue ;;
633 esac
634 fi
635 missing_src=
636 missing_dst=
637
638 test $mod_src = 160000 &&
Miklos Vajna30353a42008-12-03 14:26:52 +0100639 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
Ping Yin1cb639e2008-03-11 21:52:16 +0800640 missing_src=t
641
642 test $mod_dst = 160000 &&
Miklos Vajna30353a42008-12-03 14:26:52 +0100643 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
Ping Yin1cb639e2008-03-11 21:52:16 +0800644 missing_dst=t
645
646 total_commits=
647 case "$missing_src,$missing_dst" in
648 t,)
649 errmsg=" Warn: $name doesn't contain commit $sha1_src"
650 ;;
651 ,t)
652 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
653 ;;
654 t,t)
655 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
656 ;;
657 *)
658 errmsg=
659 total_commits=$(
660 if test $mod_src = 160000 -a $mod_dst = 160000
661 then
662 range="$sha1_src...$sha1_dst"
663 elif test $mod_src = 160000
664 then
665 range=$sha1_src
666 else
667 range=$sha1_dst
668 fi
669 GIT_DIR="$name/.git" \
Jeff Kingb0e621a2010-04-08 15:42:37 -0400670 git rev-list --first-parent $range -- | wc -l
Ping Yin1cb639e2008-03-11 21:52:16 +0800671 )
Johannes Sixteed35592008-03-12 09:30:01 +0100672 total_commits=" ($(($total_commits + 0)))"
Ping Yin1cb639e2008-03-11 21:52:16 +0800673 ;;
674 esac
675
676 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
677 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
678 if test $status = T
679 then
680 if test $mod_dst = 160000
681 then
682 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
683 else
684 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
685 fi
686 else
687 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
688 fi
689 if test -n "$errmsg"
690 then
691 # Don't give error msg for modification whose dst is not submodule
692 # i.e. deleted or changed to blob
693 test $mod_dst = 160000 && echo "$errmsg"
694 else
695 if test $mod_src = 160000 -a $mod_dst = 160000
696 then
Ping Yinf2dc06a2008-03-11 21:52:17 +0800697 limit=
698 test $summary_limit -gt 0 && limit="-$summary_limit"
Ping Yin1cb639e2008-03-11 21:52:16 +0800699 GIT_DIR="$name/.git" \
Ping Yinf2dc06a2008-03-11 21:52:17 +0800700 git log $limit --pretty='format: %m %s' \
Ping Yin1cb639e2008-03-11 21:52:16 +0800701 --first-parent $sha1_src...$sha1_dst
702 elif test $mod_dst = 160000
703 then
704 GIT_DIR="$name/.git" \
705 git log --pretty='format: > %s' -1 $sha1_dst
706 else
707 GIT_DIR="$name/.git" \
708 git log --pretty='format: < %s' -1 $sha1_src
709 fi
710 echo
711 fi
712 echo
Ping Yind0f64dd2008-04-12 23:05:31 +0800713 done |
714 if test -n "$for_status"; then
Jens Lehmannf17a5d32010-01-17 20:42:31 +0100715 if [ -n "$files" ]; then
716 echo "# Submodules changed but not updated:"
717 else
718 echo "# Submodule changes to be committed:"
719 fi
Ping Yind0f64dd2008-04-12 23:05:31 +0800720 echo "#"
721 sed -e 's|^|# |' -e 's|^# $|#|'
722 else
723 cat
724 fi
Ping Yin28f9af52008-03-11 21:52:15 +0800725}
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200726#
Lars Hjemli941987a2007-06-11 21:12:24 +0200727# List all submodules, prefixed with:
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200728# - submodule not initialized
729# + different revision checked out
730#
731# If --cached was specified the revision in the index will be printed
732# instead of the currently checked out revision.
733#
734# $@ = requested paths (default to all)
735#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800736cmd_status()
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200737{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800738 # parse $args after "submodule ... status".
Kevin Ballard98dbe632010-11-02 23:26:25 -0700739 orig_flags=
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800740 while test $# -ne 0
741 do
742 case "$1" in
743 -q|--quiet)
Stephen Boyd2e6a30e2009-06-16 15:33:00 -0700744 GIT_QUIET=1
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800745 ;;
746 --cached)
747 cached=1
748 ;;
Johan Herland64b19ff2009-08-19 03:45:24 +0200749 --recursive)
750 recursive=1
751 ;;
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800752 --)
753 shift
754 break
755 ;;
756 -*)
757 usage
758 ;;
759 *)
760 break
761 ;;
762 esac
Kevin Ballard98dbe632010-11-02 23:26:25 -0700763 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800764 shift
765 done
766
David Aguilara7b32692008-08-22 00:30:50 -0700767 module_list "$@" |
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200768 while read mode sha1 stage path
769 do
Lars Hjemli941987a2007-06-11 21:12:24 +0200770 name=$(module_name "$path") || exit
Junio C Hamano5be60072007-07-02 22:52:14 -0700771 url=$(git config submodule."$name".url)
Johan Herland64b19ff2009-08-19 03:45:24 +0200772 displaypath="$prefix$path"
Lars Hjemliba88a1f2008-02-20 23:13:15 +0100773 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200774 then
Johan Herland64b19ff2009-08-19 03:45:24 +0200775 say "-$sha1 $displaypath"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200776 continue;
777 fi
CJ van den Berg41c7c1b2007-07-04 18:22:14 +0200778 set_name_rev "$path" "$sha1"
Jens Lehmann18076502010-06-25 16:56:02 +0200779 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200780 then
Johan Herland64b19ff2009-08-19 03:45:24 +0200781 say " $sha1 $displaypath$revname"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200782 else
783 if test -z "$cached"
784 then
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100785 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
CJ van den Berg41c7c1b2007-07-04 18:22:14 +0200786 set_name_rev "$path" "$sha1"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200787 fi
Johan Herland64b19ff2009-08-19 03:45:24 +0200788 say "+$sha1 $displaypath$revname"
789 fi
790
791 if test -n "$recursive"
792 then
793 (
794 prefix="$displaypath/"
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100795 clear_local_git_env
Johan Herland64b19ff2009-08-19 03:45:24 +0200796 cd "$path" &&
Kevin Ballarda7eff1a2010-11-02 23:26:24 -0700797 eval cmd_status "$orig_args"
Johan Herland64b19ff2009-08-19 03:45:24 +0200798 ) ||
799 die "Failed to recurse into submodule path '$path'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200800 fi
801 done
802}
David Aguilar2327f612008-08-24 12:43:37 -0700803#
804# Sync remote urls for submodules
805# This makes the value for remote.$remote.url match the value
806# specified in .gitmodules.
807#
808cmd_sync()
809{
810 while test $# -ne 0
811 do
812 case "$1" in
813 -q|--quiet)
Stephen Boyd2e6a30e2009-06-16 15:33:00 -0700814 GIT_QUIET=1
David Aguilar2327f612008-08-24 12:43:37 -0700815 shift
816 ;;
817 --)
818 shift
819 break
820 ;;
821 -*)
822 usage
823 ;;
824 *)
825 break
826 ;;
827 esac
828 done
829 cd_to_toplevel
830 module_list "$@" |
831 while read mode sha1 stage path
832 do
833 name=$(module_name "$path")
834 url=$(git config -f .gitmodules --get submodule."$name".url)
Johan Herlandbaede9f2008-09-22 18:08:31 +0200835
836 # Possibly a url relative to parent
837 case "$url" in
838 ./*|../*)
839 url=$(resolve_relative_url "$url") || exit
840 ;;
841 esac
842
Andreas Köhler33f072f2010-10-08 03:07:48 +0200843 say "Synchronizing submodule url for '$name'"
844 git config submodule."$name".url "$url"
845
David Aguilar2327f612008-08-24 12:43:37 -0700846 if test -e "$path"/.git
847 then
848 (
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100849 clear_local_git_env
David Aguilar2327f612008-08-24 12:43:37 -0700850 cd "$path"
851 remote=$(get_default_remote)
David Aguilar2327f612008-08-24 12:43:37 -0700852 git config remote."$remote".url "$url"
853 )
854 fi
855 done
856}
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200857
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800858# This loop parses the command line arguments to find the
859# subcommand name to dispatch. Parsing of the subcommand specific
860# options are primarily done by the subcommand implementations.
861# Subcommand specific options such as --branch and --cached are
862# parsed here as well, for backward compatibility.
863
864while test $# != 0 && test -z "$command"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200865do
866 case "$1" in
David Aguilar2327f612008-08-24 12:43:37 -0700867 add | foreach | init | update | status | summary | sync)
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800868 command=$1
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200869 ;;
870 -q|--quiet)
Stephen Boyd2e6a30e2009-06-16 15:33:00 -0700871 GIT_QUIET=1
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200872 ;;
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200873 -b|--branch)
874 case "$2" in
875 '')
876 usage
877 ;;
878 esac
879 branch="$2"; shift
880 ;;
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200881 --cached)
Ping Yin28f9af52008-03-11 21:52:15 +0800882 cached="$1"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200883 ;;
884 --)
885 break
886 ;;
887 -*)
888 usage
889 ;;
890 *)
891 break
892 ;;
893 esac
894 shift
895done
896
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800897# No command word defaults to "status"
898test -n "$command" || command=status
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200899
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800900# "-b branch" is accepted only by "add"
901if test -n "$branch" && test "$command" != add
902then
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200903 usage
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800904fi
905
Ping Yin28f9af52008-03-11 21:52:15 +0800906# "--cached" is accepted only by "status" and "summary"
907if test -n "$cached" && test "$command" != status -a "$command" != summary
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800908then
909 usage
910fi
911
912"cmd_$command" "$@"